//-Player ThinkFrame-
CBW_Battle.PlayerThinkFrame = function(player)
	local pmo = player.mo
	//Validity check
	if not(pmo and pmo.valid) or player.playerstate != PST_LIVE then return end
	//Game Mode Check
	if maptol&(TOL_NIGHTS|TOL_XMAS) then return end
	//Update timers/stats
	player.charmedtime = max(0,$-1)
	player.actioncooldown = max(0,$-1)
	CBW_Battle.DoCharmed(player)
	CBW_Battle.DoBackdraft(player)
	
	//PvP Collision
	CBW_Battle.DoPlayerInteract(pmo,pmo.pushed)
	CBW_Battle.UpdateRecoilState(pmo)
	CBW_Battle.UpdateCollisionHistory(pmo)

	//Perform Actions
	player.actionallowed = CBW_Battle.CanDoAction(player)
	local doaction = 0
	local tossflag = 0
	local throwring = 0
	if player.cmd.buttons&BT_ATTACK then
		if player.buttonhistory&BT_ATTACK then throwring = 2
		else throwring = 1
		end
	end	
	if player.cmd.buttons&BT_TOSSFLAG then
		if player.buttonhistory&BT_TOSSFLAG then tossflag = 2
		else tossflag = 1
		end
	end	
	if player.cmd.buttons&BT_FIRENORMAL then
		if player.buttonhistory&BT_FIRENORMAL then tossflag = 2
		else tossflag = 1
		end
	end	
	doaction = (tossflag|throwring)
	CBW_Battle.MasterActionScript(player,doaction,throwring,tossflag)
end