local B = CBW_Battle
local CP = B.ControlPoint

addHook("MapChange",function(map) CP.Reset() end)
addHook("MapLoad",function() CP.Generate() end)
addHook("MobjThinker",function(mo) CP.PointThinker(mo) end, MT_CONTROLPOINT)
addHook("MobjThinker",function(mo) CP.SphereThinker(mo) end, MT_CPBONUS)
addHook("MobjRemoved",function(mo)
	if mo.target then P_SpawnMobj(mo.x,mo.y,mo.z,MT_SPARK) end
end, MT_CPBONUS)
addHook("ThinkFrame",function() CP.ThinkFrame() end)
addHook("TouchSpecial",function(smo,pmo)
	if pmo and pmo.player and smo == pmo.target then pmo.player.homing = 0 end
	return true 
end,MT_CONTROLPOINT)